#!/usr/bin/env bash

# Copyright 2023 The cert-manager Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set -o errexit
set -o nounset
set -o pipefail

REPO_ROOT="${REPO_ROOT:-$(cd "$(dirname "$0")/../.." && pwd)}"

CRDOC=${REPO_ROOT}/scripts/bin/crdoc

tmpdir="$(mktemp -d)"

cleanup() {
	echo "+++ Cleaning up tmpdir"
	rm -rf "${tmpdir}"
}
trap cleanup EXIT

checkout() {
	ref="$1"

	pushd "$tmpdir"

	echo "+++ Checking out ref $ref"

	git fetch origin "$ref"
	git reset --hard "$ref"
}

gendocs() {
	outputdir="$1"

	echo "+++ Generating reference docs..."

	$CRDOC \
    --resources "$tmpdir/deploy/crds/policy.cert-manager.io_certificaterequestpolicies.yaml" \
		--template $REPO_ROOT/scripts/gendocs/templates-approver-policy/markdown.tmpl \
		--output $outputdir
}

echo "+++ Cloning repository..."
git clone "https://github.com/cert-manager/approver-policy.git" "$tmpdir"

checkout "main"

gendocs "$REPO_ROOT/content/docs/policy/approval/approver-policy/api-reference.md"
